﻿using System;
using System.Threading;
using System.Globalization;

namespace MantisCrash
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Choose the culture : fr-[F]R or en_[U]S");

            bool ok = false;

            do
            {
                ConsoleKeyInfo k = Console.ReadKey(true);
                switch (k.Key)
                {
                    case ConsoleKey.F:
                        Console.WriteLine("Changing culture to fr-FR.");
                        Thread.CurrentThread.CurrentCulture = new CultureInfo("fr-FR", false);
                        ok = true;
                        break;
                    case ConsoleKey.U:
                        Console.WriteLine("Changing culture to en-US.");
                        Thread.CurrentThread.CurrentCulture = new CultureInfo("en-US", false);
                        ok = true;
                        break;
                    default:
                        Console.WriteLine("Answer [F] to run with French culture, or [U] to run with US culture.");
                        break;
                }
            }
            while (!ok);

            MantisConnect.MantisConnectPortTypeClient client = new MantisConnect.MantisConnectPortTypeClient();
            
            // Those credentials will throw an error in the MantisConnect service.
            client.ClientCredentials.UserName.UserName = "toto";
            client.ClientCredentials.UserName.Password = "toto";

            Console.WriteLine("Connecting to Mantis WebServices.");
            Console.WriteLine("Connected to Mantis version  {0}.", client.mc_version());
            Console.WriteLine();

            Console.WriteLine("Do you want to [D]isplay the error in the program, or make it [C]rash and see the error in a debuger ?");

            ok = false;
            int projectsCount;

            do
            {
                ConsoleKeyInfo k = Console.ReadKey(true);
                switch (k.Key)
                {
                    case ConsoleKey.D:
                        try
                        {
                            projectsCount = client.mc_projects_get_user_accessible(client.ClientCredentials.UserName.UserName, client.ClientCredentials.UserName.Password).Length;
                            Console.WriteLine("User {0} has access to {1} project(s).", client.ClientCredentials.UserName.UserName, projectsCount);
                        }
                        catch (Exception e)
                        {
                            int level = 1;
                            while (e != null)
                            {
                                Console.WriteLine("Error level {0} : {1}.", level, e.Message);
                                e = e.InnerException;
                                level++;
                            }
                        }
                        finally
                        {
                            ok = true;
                        }
                        break;
                    case ConsoleKey.C:
                        projectsCount = client.mc_projects_get_user_accessible(client.ClientCredentials.UserName.UserName, client.ClientCredentials.UserName.Password).Length;
                        Console.WriteLine("User {0} has access to {1} project(s).", client.ClientCredentials.UserName.UserName, projectsCount);
                        ok = true;
                        break;
                    default:
                        Console.WriteLine("Answer [D] to display error, or [C] to let the program crash and see the exception in the debuger.");
                        break;
                }
            }
            while (!ok);

            Console.WriteLine();
            Console.WriteLine("Hit any key to end the program.");
            Console.ReadKey(true);
        }
    }
}
